Bug 475621 - [LTC 5.4 FEAT] Enable SOL (serial over lan) usage for Cell systems with RHEL5 [201454]
[LTC 5.4 FEAT] Enable SOL (serial over lan) usage for Cell systems with RHEL5...
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.4
ppc64 All
high Severity high
: rc
: 5.4
Assigned To: Ameet Paranjape
Red Hat Kernel QE team
: FutureFeature, OtherQA
: 439502 (view as bug list)
Depends On:
Blocks: 445204 483701 483784 485920
  Show dependency treegraph
 
Reported: 2008-12-09 15:11 EST by IBM Bug Proxy
Modified: 2009-09-02 04:15 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 04:15:55 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
makes serial console working reliable with RHEL on QS2x (4.76 KB, text/plain)
2009-01-23 11:41 EST, IBM Bug Proxy
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
IBM Linux Technology Center 50375 None None None Never

  None (edit)
Description IBM Bug Proxy 2008-12-09 15:11:14 EST
=Comment: #0=================================================
Emily J. Ratliff <ratliff@austin.ibm.com> - 
1. Feature Overview:
Feature Id:	[201454]
a. Name of Feature:	Enable SOL (serial over lan) usage for Cell systems with RHEL5
b. Feature Description
After installation of RHEL5.1 yaboot.conf contains a kernel parameter 'console=ttyS0'. This results
in that the kernel tries to set SOL to a speed higher than 19200. SOL only supports 19200 and the
subsequent output is garbage. Either removing this parameter or extending it to
'console=ttyS0,19200' fixes this problem. However, the next problem is then the getty process on the
console, which sets the unsupported speed again. This can be fixed by changing the entry in
/etc/inittab to: tty:2345:respawn:/sbin/agetty ttyS0 19200 vt100-nav . This problem was already
addressed for Fedora 8 in Red Hat bugzilla 400191: anaconda sets wrong default baud rate for serial
tty on a QS21.

More information in LTC bug 43401 - RHBZ 439502 - LTC:5.3:201454:Enable SOL (serial over lan) usage
for Cell systems with RHEL5

2. Feature Details:
Sponsor:	QDC
Architectures:
ppc64

Arch Specificity: Purely Arch Specific Code
Affects Installer: Yes
Delivery Mechanism: Request Red Hat development assistance
Category:	Cell
Request Type:	Installer - Enhancement from Distributor
d. Upstream Acceptance:	No Code Required
Sponsor Priority	3
f. Severity: Medium
IBM Confidential:	no
Code Contribution:	no
g. Component Version Target:	

3. Business Case
Better support for Cell systems during installation will help the customer in a better use and
acceptance of Cell systems

4. Primary contact at Red Hat: 
John Jarvis
jjarvis@redhat.com

5. Primary contacts at Partner:
Project Management Contact:
Hanns-Joachim Uhl, hannsj_uhl@de.ibm.com, 49-7031-16-4198

Technical contact(s):

Hanns-Joachim Uhl, hannsj_uhl@de.ibm.com
Comment 1 John Jarvis 2008-12-22 12:50:56 EST
IBM is signed up to test and provide feedback.
Comment 2 John Jarvis 2008-12-22 16:27:05 EST
*** Bug 439502 has been marked as a duplicate of this bug. ***
Comment 3 IBM Bug Proxy 2008-12-22 16:32:53 EST
Emily J. Ratliff <emilyr@us.ibm.com> - 2008-03-24 11:14 EDT
1. Feature Id:	[201454]
Feature Name:	Enable SOL (serial over lan) usage for Cell systems with RHEL5

2. Short Description
console, which sets
the unsupported speed again. This can be fixed by changing the entry in /etc/inittab to:
tty:2345:respawn:/sbin/agetty ttyS0 19200 vt100-nav . This problem was already addressed for Fedora
8 in Red Hat bugzilla 400191: anaconda sets wrong default baud rate for serial tty on a QS21.


4. Sponsor Priority	2
Upstream Acceptance:	No Code Required
Component Version Target:
Performance Assistance:

5. PM Contact:	Hanns-Joachim Uhl, hannsj_uhl@de.ibm.com, 49-7031-16-4198

6. Technical contact(s):

IBM is signed up to test and provide feedback
Test only, ACK.
This enhancement request was evaluated by the full Red Hat Enterprise Linux team
for inclusion in a Red Hat Enterprise Linux minor release.   As a result of this
evaluation, Red Hat has tentatively approved inclusion of this feature in the
next Red Hat Enterprise Linux Update minor release.   While it is a goal to
include this enhancement in the next minor release of Red Hat Enterprise Linux,
the enhancement is not yet committed for inclusion in the next minor release
pending the next phase of actual code integration and successful Red Hat and
partner testing.

Did this ever get tested with 5.3?
Hello Red Hat,
we retested this bugzilla with RHEL5.3 Snapshot 3 and the situation is unchanged as e.g. documented for RHEL5.1/5.2 in the IBM Retain Tip at
https://www-304.ibm.com/systems/support/supportsite.wss/docdisplay?lndocid=MIGR-5077680&brandind=5000020
I.e. this RHEL5.3 feature request is not resolved and I am closing this bugzilla now as 'won't fix''' and 'documented' for RHEL5.3.
Thanks for your support.
Yes, sorry for the confusion. This bug is being proposed for inclusion in RHEL 5.4.0.
(In reply to comment #16)
> Did this ever get tested with 5.3?
>

Yes, I just tested it with RHEL 5.3 Snapshot 3 and this is the result:

Linux version 2.6.18-123.el5 (brewbuilder@js20-bc2-11.build.redhat.com) (gcc version 4.1.2 20071124 (Red Hat 4.1.2-42)) #1 SMP Mon Nov 10 18:34:28 EST 2008
*** 0000 : CF000012

*** 0000 : Setup Arch
[boot]0012 Setup Arch
mmio NVRAM, 1020k at 0x14502000000 mapped to d000080080070000
*** 0000 : CF000015

*** 0000 : Setup Done
[boot]0015 Setup Done
Built 2 zonelists.  Total pages: 262144
Kernel command line: root=/dev/VolGroup00/LogVol00 ro console=ttyS0 rhgb quiet
???????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????
according to the comment in https://bugzilla.redhat.com/show_bug.cgi?id=400191#c7 , this is requires a kernel patch or hardware fix, not an installer fix.  What is IBM's plan to fix this functionality?
*** This bug has been marked as a duplicate of 475621 ***
Comment 4 Roman Rakus 2009-01-05 09:20:57 EST
I don't know why is this bug against yaboot. Shouldn't be it against anaconda and/or initscripts?
Comment 5 IBM Bug Proxy 2009-01-14 09:40:32 EST
Working with the FW developers on the IBM side.  The FW is presenting Linux with the correct speed:

/axon@10000000000/plb5/plb4/opb/serial@40000200 ok

0 > .properties

clock-frequency                  00e10000

current-speed                    00004b00  <-------- here (19200 decimal)

compatible                       ns16750ns16550ns16450i8250

6e733136  37353000  6e733136  35353000

6e733136  34353000  69383235  3000

interrupts                       00000000  00000002

reg                              40000200  00000008

#interrupt-cells                 00000002

device_type                      serial

73657269  616c00

name                             serial

73657269  616c00 ok

0 >
Comment 6 IBM Bug Proxy 2009-01-14 15:51:22 EST
The 8250 serial driver is not capable of probing the current port speed. Additionally, it provides no way for our architecture code to specify the speed we want other than the kernel command line.

If you don't specify a console= command line argument, then our arch code will fill it up with the appropriate values. But if you do, then it's considered as a manual override and there's nothing we can do to provide the port speed.

This is a limitation of the generic linux serial driver as far as I can tell.

I've discussed with the driver author (Russell King), and it would be possible to make it somewhat probe for the current port speed, though it's hard to tell what impact that can have on other machines at this stage.
Comment 7 IBM Bug Proxy 2009-01-15 05:10:50 EST
*** This bug has been marked as a duplicate of bug 50375 ***
Comment 8 IBM Bug Proxy 2009-01-15 05:11:08 EST
*** Bug 43401 has been marked as a duplicate of this bug. ***
Comment 9 IBM Bug Proxy 2009-01-23 11:41:12 EST
Created attachment 329854 [details]
makes serial console working reliable with RHEL on QS2x



The patch adds a flag to the of_serial driver, so that setserial cannot change the baud rate anymore.
The result is a working serial console without the need of specifying the correct baud rate on the kernel command line.
Comment 10 IBM Bug Proxy 2009-01-23 11:51:18 EST
Hello Red Hat,
fyi .. as you can see from the patch this patch was backported from a kernel patch which was accepted upstream in kernel 2.6.22 ..
Please keep me informed in case of any questions.
Thanks in advance for your support.
Comment 12 RHEL Product and Program Management 2009-02-16 10:19:36 EST
Updating PM score.
Comment 13 John Jarvis 2009-03-02 12:51:46 EST
This enhancement request was evaluated by the full Red Hat Enterprise Linux team
for inclusion in a Red Hat Enterprise Linux minor release.   As a result of this
evaluation, Red Hat has tentatively approved inclusion of this feature in the
next Red Hat Enterprise Linux Update minor release.   While it is a goal to
include this enhancement in the next minor release of Red Hat Enterprise Linux,
the enhancement is not yet committed for inclusion in the next minor release
pending the next phase of actual code integration and successful Red Hat and
partner testing.
Comment 14 Don Zickus 2009-03-04 15:00:31 EST
in kernel-2.6.18-133.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.
Comment 16 IBM Bug Proxy 2009-03-05 09:30:43 EST
I installed 2.6.18-133.el5 and removed the 19200 option from the console=ttyS0 parameter in yaboot.conf and now I get the following output. As can be seen, there is more readable output compared to for example the output in comment #7, but eventually the output becomes unreadable .. until the getty process takes over.

Console output:

Please wait, loading kernel...
..   Elf64 kernel loaded...
Loading ramdisk...
.ramdisk loaded at 01500000, size: 2792 Kbytes
OF stdout device is: /axon@10000000000/plb5/plb4/opb/serial@40000200
command line: ro console=ttyS0 rhgb root=LABEL=/1 crashkernel=256M@32M
memory layout at init:
alloc_bottom : 00000000017c0000
alloc_top    : 0000000030000000
alloc_top_hi : 0000000200000000
rmo_top      : 0000000030000000
ram_top      : 0000000200000000
Looking for displays
instantiating rtas at 0x000000002fff0000 ... done
0000000000000000 : boot cpu     0000000000000000
0000000000000002 : starting cpu hw idx 0000000000000002... done
copying OF device tree ...
Building dt strings...
Building dt structure...
Device tree strings 0x00000000019d0000 -> 0x00000000019d0a53
Device tree struct  0x00000000019e0000 -> 0x00000000019f0000
Starting Linux PPC64 #1 SMP Tue Mar 3 20:19:24 EST 2009
-----------------------------------------------------
ppc64_pft_size                = 0x0
physicalMemorySize            = 0x200000000
ppc64_caches.dcache_line_size = 0x80
ppc64_caches.icache_line_size = 0x80
htab_address                  = 0xc000000078000000
htab_hash_mask                = 0xfffff
-----------------------------------------------------
Linux version 2.6.18-133.el5 (mockbuild@js20-bc2-11.build.redhat.com) (gcc version 4.1.2 20080704 (Red Hat 4.1.2-44)) #1 SMP Tue Mar 3 20:19:24 EST 2009
*** 0000 : CF000012

*** 0000 : Setup Arch
[boot]0012 Setup Arch
mmio NVRAM, 1020k at 0x14502000000 mapped to d000080080070000
*** 0000 : CF000015

*** 0000 : Setup Done
[boot]0015 Setup Done
Built 2 zonelists.  Total pages: 131072
Kernel command line: ro console=ttyS0 rhgb root=LABEL=/1 crashkernel=256M@32M
IIC for CPU 0 target id 0xe : /be@20000000000/interrupt-controller@508400
IIC for CPU 1 target id 0xf : /be@20000000000/interrupt-controller@508400
IIC for CPU 2 target id 0x1e : /be@20100000000/interrupt-controller@508400
IIC for CPU 3 target id 0x1f : /be@20100000000/interrupt-controller@508400
mpic: Setting up MPIC " MPIC     " version 1.2 at 0, max 4 CPUs
mpic: ISU size: 128, shift: 7, mask: 7f
mpic: Initializing for 128 sources
/axon@10000000000/interrupt-controller : hooking up to IRQ 43
mpic: Setting up MPIC " MPIC     " version 1.2 at 0, max 4 CPUs
mpic: ISU size: 128, shift: 7, mask: 7f
mpic: Initializing for 128 sources
/axon@30000000000/interrupt-controller : hooking up to IRQ 299
PID hash table entries: 4096 (order: 12, 32768 bytes)
??????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????
...
lots of unreadable characters removed
...
????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????
Red Hat Enterprise Linux Server release 5.3 (Tikanga)
Kernel 2.6.18-133.el5 on an ppc64

c4b5 login:
Comment 17 IBM Bug Proxy 2009-03-25 08:10:14 EDT
------- Comment From gerhard.stenzel@de.ibm.com 2009-03-25 08:09 EDT-------
(In reply to comment #26)
> I installed 2.6.18-133.el5 and removed the 19200 option from the console=ttyS0
> parameter in yaboot.conf and now I get the following output. As can be seen,
> there is more readable output compared to for example the output in comment #7,
> but eventually the output becomes unreadable .. until the getty process takes
> over.

It turns out, that is not sufficient to only remove the 19200 option. It is necessary to remove the whole "console=ttyS0" parameter. Without this parameter, the patch works as expected and the feature is enabled ...  thanks again
Comment 21 Chris Ward 2009-06-14 19:18:43 EDT
~~ Attention Partners RHEL 5.4 Partner Alpha Released! ~~

RHEL 5.4 Partner Alpha has been released on partners.redhat.com. There should
be a fix present that addresses this particular request. Please test and report back your results here, at your earliest convenience. Our Public Beta release is just around the corner!

If you encounter any issues, please set the bug back to the ASSIGNED state and
describe the issues you encountered. If you have verified the request functions as expected, please set your Partner ID in the Partner field above to indicate successful test results. Do not flip the bug status to VERIFIED. Further questions can be directed to your Red Hat Partner Manager. Thanks!
Comment 22 Chris Ward 2009-07-03 14:17:03 EDT
~~ Attention - RHEL 5.4 Beta Released! ~~

RHEL 5.4 Beta has been released! There should be a fix present in the Beta release that addresses this particular request. Please test and report back results here, at your earliest convenience. RHEL 5.4 General Availability release is just around the corner!

If you encounter any issues while testing Beta, please describe the issues you have encountered and set the bug into NEED_INFO. If you encounter new issues, please clone this bug to open a new issue and request it be reviewed for inclusion in RHEL 5.4 or a later update, if it is not of urgent severity.

Please do not flip the bug status to VERIFIED. Only post your verification results, and if available, update Verified field with the appropriate value.

Questions can be posted to this bug or your customer or partner representative.
Comment 23 IBM Bug Proxy 2009-07-09 04:41:16 EDT
------- Comment From gerhard.stenzel@de.ibm.com 2009-07-09 04:37 EDT-------
Verified in RHEL 5.4 Beta .. closing Bugzilla
Comment 25 errata-xmlrpc 2009-09-02 04:15:55 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1243.html

Note You need to log in before you can comment on or make changes to this bug.